--
-- doorOpenerV3 - linke, rechte Tre & Haube
--
--[[

Moddesc.xml
----------------------------------------------------------------------------------------------------------------------------------
<specialization name="doorOpenerV3" className="doorOpenerV3" filename="scripts/doorOpenerV3.lua" />

<input name="SET_doorOpenerV3" category="onfoot" key1="KEY_r" key2="" button="" device="0" mouse="" />

<text name="SET_doorOpenerV3"><en>Open/Close door</en><de>Tr ffnen/schlieen</de></text>
<text name="SET_LEFTdoorOpenerV3"><en>Open/Close door</en><de>Tr ffnen/schlieen</de></text>
<text name="SET_RIGHTdoorOpenerV3"><en>Open/Close door</en><de>Tr ffnen/schlieen</de></text>
<text name="SET_hoodOPENER"><en>Motorhaube</en><de>Motorhaube</de></text>


Vehicle.xml
----------------------------------------------------------------------------------------------------------------------------------
	<leftdoorOpenerV3	trigger="0>x" icIndex="1" />
    <rightdoorOpenerV3	trigger="0>x" icIndex="2" />
	<hoodOpener			trigger="0>x" icIndex="3" />

]]--

doorOpenerV3 = {};

doorOpenerV3.modDir = g_currentModDirectory;

function doorOpenerV3.prerequisitesPresent(specializations)
    return true; 
end;

function doorOpenerV3:load(savegame)
--  left door
	self.playerCallbackLeftDoor = SpecializationUtil.callSpecializationsFunction("playerCallbackLeftDoor"); 
	
	self.doorO = {};
	
	local trigger = Utils.indexToObject( self.components, getXMLString(self.xmlFile, string.format("vehicle.leftdoorOpenerV3#trigger")) );
	if trigger == nil then
		print("[Error::LeftdoorOpenerV3] node is OK, but trigger could not be located. Check line "..tostring(i+1).." in your vehicle.xml");
	end;
	
	local icIndex = getXMLInt(self.xmlFile, string.format("vehicle.leftdoorOpenerV3#icIndex", i));
	
	self.doorO.icIndex = icIndex;
	self.doorO.trigger = trigger;
	self.doorO.plIR = false;
	
	addTrigger( trigger, "playerCallbackLeftDoor", self );
	
--  right door	
	self.playerCallbackRightDoor = SpecializationUtil.callSpecializationsFunction("playerCallbackRightDoor"); 
	
	self.door1 = {};
	
	local trigger = Utils.indexToObject( self.components, getXMLString(self.xmlFile, string.format("vehicle.RightdoorOpenerV3#trigger")) );
	if trigger == nil then
		print("[Error::RightdoorOpenerV3] node is OK, but trigger could not be located. Check line "..tostring(i+1).." in your vehicle.xml");
	end;
	
	local icIndex = getXMLInt(self.xmlFile, string.format("vehicle.rightdoorOpenerV3#icIndex", i));
	
	self.door1.icIndex = icIndex;
	self.door1.trigger = trigger;
	self.door1.plIR = false;
		
	addTrigger( trigger, "playerCallbackRightDoor", self );
	
--  hood
	self.playerCallbackhood = SpecializationUtil.callSpecializationsFunction("playerCallbackhood"); 
	
	self.door2 = {};
	
	local trigger = Utils.indexToObject( self.components, getXMLString(self.xmlFile, string.format("vehicle.hoodOpener#trigger")) );
	if trigger == nil then
		print("[Error::hoodOpener] node is OK, but trigger could not be located. Check line "..tostring(i+1).." in your vehicle.xml");
	end;
	
	local icIndex = getXMLInt(self.xmlFile, string.format("vehicle.hoodOpener#icIndex", i));
	
	self.door2.icIndex = icIndex;
	self.door2.trigger = trigger;
	self.door2.plIR = false;
		
	addTrigger( trigger, "playerCallbackhood", self );	
end;

function doorOpenerV3:delete()
-- left door
	if self.doorO.trigger ~= nil then
		removeTrigger(self.doorO.trigger);
	end;
--  right door
	if self.door1.trigger ~= nil then
		removeTrigger(self.door1.trigger);
	end;
--  hood
	if self.door2.trigger ~= nil then
		removeTrigger(self.door2.trigger);
	end;	
end;

function doorOpenerV3:readStream(streamId, connection)
end;

function doorOpenerV3:writeStream(streamId, connection)
end;

function doorOpenerV3:mouseEvent(posX, posY, isDown, isUp, button)
end;

function doorOpenerV3:keyEvent(unicode, sym, modifier, isDown)
end;

function doorOpenerV3:update(dt)
	if self.doorO.plIR then
		g_currentMission:addHelpButtonText( g_i18n:getText("SET_LEFTdoorOpenerV3"), InputBinding.SET_doorOpenerV3 );	
		setTextColor(1.0, 1.0, 1.0, 1.0);
		setTextAlignment(RenderText.ALIGN_LEFT); 				
		renderText( 0.5, 0.06, 0.02, g_i18n:getText("SET_LEFTdoorOpenerV3") );
		if InputBinding.hasEvent(InputBinding.SET_doorOpenerV3)then
			local obj = self.interactiveObjects[self.doorO.icIndex];
			if obj ~= nil then
				self:doActionOnObject(self.doorO.icIndex);
			end;
		end
	end;
	if self.door1.plIR then
		g_currentMission:addHelpButtonText( g_i18n:getText("SET_RIGHTdoorOpenerV3"), InputBinding.SET_doorOpenerV3 );	
		setTextColor(1.0, 1.0, 1.0, 1.0);
		setTextAlignment(RenderText.ALIGN_LEFT); 				
		renderText( 0.5, 0.06, 0.02, g_i18n:getText("SET_RIGHTdoorOpenerV3") );
		if InputBinding.hasEvent(InputBinding.SET_doorOpenerV3)then
			local obj = self.interactiveObjects[self.door1.icIndex];
			if obj ~= nil then
				self:doActionOnObject(self.door1.icIndex);
			end;
		end
	end;
	if self.door2.plIR then
		g_currentMission:addHelpButtonText( g_i18n:getText("SET_hoodOPENER"), InputBinding.SET_doorOpenerV3 );	
		setTextColor(1.0, 1.0, 1.0, 1.0);
		setTextAlignment(RenderText.ALIGN_LEFT); 				
		renderText( 0.5, 0.06, 0.02, g_i18n:getText("SET_hoodOPENER") );
		if InputBinding.hasEvent(InputBinding.SET_doorOpenerV3)then
			local obj = self.interactiveObjects[self.door2.icIndex];
			if obj ~= nil then
				self:doActionOnObject(self.door2.icIndex);
			end;
		end
	end;	
end;

function doorOpenerV3:onLeave()
end;

function doorOpenerV3:draw()
end;

function doorOpenerV3:playerCallbackLeftDoor(triggerId, otherId, onEnter, onLeave, onStay)
	if onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.doorO.plIR = true;
	elseif onLeave and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.doorO.plIR = false;
	end;
end;

function doorOpenerV3:playerCallbackRightDoor(triggerId, otherId, onEnter, onLeave, onStay)
	if onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.door1.plIR = true;
	elseif onLeave and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.door1.plIR = false;
	end;
end;

function doorOpenerV3:playerCallbackhood(triggerId, otherId, onEnter, onLeave, onStay)
	if onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.door2.plIR = true;
	elseif onLeave and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.door2.plIR = false;
	end;
end;